package UI.GameState;
/*** In The Name of Allah ***/

import UI.GameFrame;

import java.awt.event.*;


/**
 * This class holds the state of the game and all of its elements.
 * This class also handles user inputs, which affect the game state.
 *
 * @author Seyede zahra seyed fatehi
 */
public class TankState {

    public int locX, locY, diam, rotate;
    public boolean gameOver;

    private boolean keyUP, keyDOWN, keyRIGHT, keyLEFT , keySpace;
    private boolean mousePress;
    private int mouseX, mouseY;
    private KeyHandler keyHandler;
    private MouseHandler mouseHandler;
    private WallState walls;
    BulletState bulletState = new BulletState(walls , TankState.this);

    public TankState(){
    }

    public TankState(WallState walls) {
        this.walls = walls;
        // Initialize the game state and all elements ...
        locX = 100;
        locY = 100;
        rotate = 0;

        diam = 32;
        gameOver = false;

        keyUP = false;
        keyDOWN = false;
        keyRIGHT = false;
        keyLEFT = false;
        keySpace = false;

        mousePress = false;
        mouseX = 0;
        mouseY = 0;

        keyHandler = new KeyHandler();
        mouseHandler = new MouseHandler();
        keyHandler = new KeyHandler();
        mouseHandler = new MouseHandler();
    }

    /**
     * The method which updates the game state.
     */
    public void update() {
        //
        // Update the state of all game elements
        //  based on user input and elapsed time ...
        //

        int lastx = locX,lasty = locY,lastr = rotate;

        if (mousePress) {
            locY = mouseY - diam / 2;
            locX = mouseX - diam / 2;
        }
        if (keyUP) {
            rotate = rotate % 360;
            locY -= 8;
            if ( (rotate> 90 && rotate <180) || rotate== 90 )
                rotate +=10;
            else if ( (rotate >180 && rotate < 270) || rotate ==270 )
                rotate -=10;
            else
                rotate =180;
        }
        if (keyDOWN) {
            rotate = rotate % 360;
            locY += 8;
            if ( (rotate > 270 && rotate < 360) || rotate ==270 )
                rotate +=10;
            else if ( (rotate < 90 && rotate > 0) || rotate == 90 )
                rotate -=10;
            else
                rotate = 0;
        }
        if (keyLEFT ){
            rotate = rotate % 360;
            locX -= 8;
            if ( (rotate  > 0 && rotate < 90 )|| rotate == 0)
                rotate +=10;
            else if ( (rotate > 90 && rotate <180 )|| rotate == 180 )
                rotate -=10;
            else
                rotate = 90;
        }
        if (keyRIGHT ) {
            rotate = rotate % 360;
            locX += 8;
            if ((rotate > 180 && rotate < 270)|| rotate ==180 )
                rotate +=10;
            else if ( (rotate > 270 && rotate < 360) || rotate == 360)
                rotate -=10;
            else
                rotate =270;
        }
        if (keySpace) {

               // for (int i = 0; i < 100; i++) {
                    bulletState.locY += 5*Math.sin(rotate) ;
                    System.out.println(bulletState.locY );
                    bulletState.locX += 5*Math.cos(rotate) ;
                    System.out.println("preeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeesssssssssssssedddddddddddddd");

             //   }
      //      bulletState.locX = locX;
        //    bulletState.locY = locY;
        }

        if (walls.isWall(locX,locY)){
            locX = lastx;
            locY = lasty;
        }

        locX = Math.max(locX, 0);
        locX = Math.min(locX, GameFrame.GAME_WIDTH - diam);
        locY = Math.max(locY, 0);
        locY = Math.min(locY, GameFrame.GAME_HEIGHT - diam);

    }


    public KeyListener getKeyListener() {
        return keyHandler;
    }
    public MouseListener getMouseListener() {
        return mouseHandler;
    }
    public MouseMotionListener getMouseMotionListener() {
        return mouseHandler;
    }



    /**
     * The keyboard handler.
     */
    class KeyHandler extends KeyAdapter {

        @Override
        public void keyPressed(KeyEvent e) {

            switch (e.getKeyCode()) {
                case KeyEvent.VK_UP:
                    keyUP = true;
                    break;
                case KeyEvent.VK_DOWN:
                    keyDOWN = true;
                    break;
                case KeyEvent.VK_LEFT:
                    keyLEFT = true;
                    break;
                case KeyEvent.VK_RIGHT:
                    keyRIGHT = true;
                    break;
                case KeyEvent.VK_SPACE: {
                    keySpace = true;
                    break;
                }
                case KeyEvent.VK_ESCAPE:
                    gameOver = true;
                    break;
            }
        }

        @Override
        public void keyReleased(KeyEvent e) {
            switch (e.getKeyCode())
            {
                case KeyEvent.VK_UP:
                    keyUP = false;
                    break;
                case KeyEvent.VK_DOWN:
                    keyDOWN = false;
                    break;
                case KeyEvent.VK_LEFT:
                    keyLEFT = false;
                    break;
                case KeyEvent.VK_SPACE: {
                    keySpace = false;
                    break;
                }
                case KeyEvent.VK_RIGHT:
                    keyRIGHT = false;
                    break;
            }
        }

    }

    public void setWalls(WallState walls) {
        this.walls = walls;
    }

    /**
     * The mouse handler.
     */
    class MouseHandler extends MouseAdapter {

        @Override
        public void mousePressed(MouseEvent e) {
            mouseX = e.getX();
            mouseY = e.getY();
            mousePress = true;
        }

        @Override
        public void mouseReleased(MouseEvent e) {
            mousePress = false;
        }

        @Override
        public void mouseDragged(MouseEvent e) {
            mouseX = e.getX();
            mouseY = e.getY();
        }
    }
}

